(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/router'), require('amazon-cognito-identity-js'), require('aws-sdk/global'), require('aws-sdk/clients/sts'), require('@angular/common'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/router', 'amazon-cognito-identity-js', 'aws-sdk/global', 'aws-sdk/clients/sts', '@angular/common', '@angular/forms'], factory) :
    (global = global || self, factory((global.ng = global.ng || {}, global.ng.wngauth = {}), global.core, global.router, global.amazonCognitoIdentityJs, global.AWS, global.STS, global.common, global.forms));
}(this, function (exports, core, router, amazonCognitoIdentityJs, AWS, STS, common, forms) { 'use strict';

    var NewPasswordUser = (function () {
        function NewPasswordUser() {
        }
        return NewPasswordUser;
    }());

    var RegistrationUser = (function () {
        function RegistrationUser() {
        }
        return RegistrationUser;
    }());

    var Stuff = (function () {
        function Stuff() {
        }
        return Stuff;
    }());

    var environment = {
        production: false,
        region: 'us-east-1',
        identityPoolId: '',
        userPoolId: 'us-east-1_kPmRA4Rqw',
        clientId: '7qej2m9pbc58j74l2247uq7nhm',
        cognito_idp_endpoint: '',
        cognito_identity_endpoint: '',
        sts_endpoint: ''
    };

    var CognitoUtil = (function () {
        function CognitoUtil() {
        }
        CognitoUtil.prototype.getUserPool = function () {
            return new amazonCognitoIdentityJs.CognitoUserPool(CognitoUtil._POOL_DATA);
        };
        CognitoUtil.prototype.getCurrentUser = function () {
            return this.getUserPool().getCurrentUser();
        };
        // AWS Stores Credentials in many ways, and with TypeScript this means that
        // getting the base credentials we authenticated with from the AWS globals gets really murky,
        // having to get around both class extension and unions. Therefore, we're going to give
        // developers direct access to the raw, unadulterated CognitoIdentityCredentials
        // object at all times.
        // AWS Stores Credentials in many ways, and with TypeScript this means that
        // getting the base credentials we authenticated with from the AWS globals gets really murky,
        // having to get around both class extension and unions. Therefore, we're going to give
        // developers direct access to the raw, unadulterated CognitoIdentityCredentials
        // object at all times.
        CognitoUtil.prototype.setCognitoCreds = 
        // AWS Stores Credentials in many ways, and with TypeScript this means that
        // getting the base credentials we authenticated with from the AWS globals gets really murky,
        // having to get around both class extension and unions. Therefore, we're going to give
        // developers direct access to the raw, unadulterated CognitoIdentityCredentials
        // object at all times.
        function (creds) {
            this.cognitoCreds = creds;
        };
        CognitoUtil.prototype.getCognitoCreds = function () {
            return this.cognitoCreds;
        };
        // This method takes in a raw jwtToken and uses the global AWS config options to build a
        // CognitoIdentityCredentials object and store it for us. It also returns the object to the caller
        // to avoid unnecessary calls to setCognitoCreds.
        // This method takes in a raw jwtToken and uses the global AWS config options to build a
        // CognitoIdentityCredentials object and store it for us. It also returns the object to the caller
        // to avoid unnecessary calls to setCognitoCreds.
        CognitoUtil.prototype.buildCognitoCreds = 
        // This method takes in a raw jwtToken and uses the global AWS config options to build a
        // CognitoIdentityCredentials object and store it for us. It also returns the object to the caller
        // to avoid unnecessary calls to setCognitoCreds.
        function (idTokenJwt) {
            var url = 'cognito-idp.' + CognitoUtil._REGION.toLowerCase() + '.amazonaws.com/' + CognitoUtil._USER_POOL_ID;
            var logins = {};
            logins[url] = idTokenJwt;
            var params = {
                IdentityPoolId: CognitoUtil._IDENTITY_POOL_ID,
                /* required */
                Logins: logins
            };
            var serviceConfigs = {};
            console.log('Building cognito credentials...');
            var creds = new AWS.CognitoIdentityCredentials(params, serviceConfigs);
            this.setCognitoCreds(creds);
            return creds;
        };
        CognitoUtil.prototype.getCognitoIdentity = function () {
            return this.cognitoCreds.identityId;
        };
        CognitoUtil.prototype.getAccessToken = function (callback) {
            if (callback == null) {
                throw ("CognitoUtil: callback in getAccessToken is null...returning");
            }
            if (this.getCurrentUser() != null) {
                this.getCurrentUser().getSession(function (err, session) {
                    if (err) {
                        console.log("CognitoUtil: Can't set the credentials:" + err);
                        callback.callbackWithParam(null);
                    }
                    else {
                        if (session.isValid()) {
                            callback.callbackWithParam(session.getAccessToken().getJwtToken());
                        }
                    }
                });
            }
            else {
                callback.callbackWithParam(null);
            }
        };
        CognitoUtil.prototype.getIdToken = function (callback) {
            if (callback == null) {
                throw ("CognitoUtil: callback in getIdToken is null...returning");
            }
            if (this.getCurrentUser() != null)
                this.getCurrentUser().getSession(function (err, session) {
                    if (err) {
                        console.log("CognitoUtil: Can't set the credentials:" + err);
                        callback.callbackWithParam(null);
                    }
                    else {
                        if (session.isValid()) {
                            callback.callbackWithParam(session.getIdToken().getJwtToken());
                        }
                        else {
                            console.log("CognitoUtil: Got the id token, but the session isn't valid");
                        }
                    }
                });
            else
                callback.callbackWithParam(null);
        };
        CognitoUtil.prototype.getRefreshToken = function (callback) {
            if (callback == null) {
                throw ("CognitoUtil: callback in getRefreshToken is null...returning");
            }
            if (this.getCurrentUser() != null)
                this.getCurrentUser().getSession(function (err, session) {
                    if (err) {
                        console.log("CognitoUtil: Can't set the credentials:" + err);
                        callback.callbackWithParam(null);
                    }
                    else {
                        if (session.isValid()) {
                            callback.callbackWithParam(session.getRefreshToken());
                        }
                    }
                });
            else
                callback.callbackWithParam(null);
        };
        CognitoUtil.prototype.refresh = function () {
            this.getCurrentUser().getSession(function (err, session) {
                if (err) {
                    console.log("CognitoUtil: Can't set the credentials:" + err);
                }
                else {
                    if (session.isValid()) {
                        console.log("CognitoUtil: refreshed successfully");
                    }
                    else {
                        console.log("CognitoUtil: refreshed but session is still not valid");
                    }
                }
            });
        };
        CognitoUtil._REGION = environment.region;
        CognitoUtil._IDENTITY_POOL_ID = environment.identityPoolId;
        CognitoUtil._USER_POOL_ID = environment.userPoolId;
        CognitoUtil._CLIENT_ID = environment.clientId;
        CognitoUtil._POOL_DATA = {
            UserPoolId: CognitoUtil._USER_POOL_ID,
            ClientId: CognitoUtil._CLIENT_ID
        };
        CognitoUtil.decorators = [
            { type: core.Injectable },
        ];
        /** @nocollapse */
        CognitoUtil.ctorParameters = function () { return []; };
        return CognitoUtil;
    }());

    var UserLoginService = (function () {
        function UserLoginService(cognitoUtil) {
            var _this = this;
            this.cognitoUtil = cognitoUtil;
            this.onLoginSuccess = function (callback, session) {
                console.log("In authenticateUser onSuccess callback");
                AWS.config.credentials = _this.cognitoUtil.buildCognitoCreds(session.getIdToken().getJwtToken());
                // So, when CognitoIdentity authenticates a user, it doesn't actually hand us the IdentityID,
                // used by many of our other handlers. This is handled by some sly underhanded calls to AWS Cognito
                // API's by the SDK itself, automatically when the first AWS SDK request is made that requires our
                // security credentials. The identity is then injected directly into the credentials object.
                // If the first SDK call we make wants to use our IdentityID, we have a
                // chicken and egg problem on our hands. We resolve this problem by "priming" the AWS SDK by calling a
                // very innocuous API call that forces this behavior.
                var clientParams = {};
                var sts = new STS(clientParams);
                sts.getCallerIdentity(function (err, data) {
                    console.log("UserLoginService: Successfully set the AWS credentials");
                    callback.cognitoCallback(null, session);
                });
            };
            this.onLoginError = function (callback, err) {
                callback.cognitoCallback(err.message, null);
            };
        }
        UserLoginService.prototype.authenticate = function (username, password, callback) {
            var _this = this;
            console.log("UserLoginService: starting the authentication");
            var authenticationData = {
                Username: username,
                Password: password,
            };
            var authenticationDetails = new amazonCognitoIdentityJs.AuthenticationDetails(authenticationData);
            var userData = {
                Username: username,
                Pool: this.cognitoUtil.getUserPool()
            };
            console.log("UserLoginService: Params set...Authenticating the user");
            var cognitoUser = new amazonCognitoIdentityJs.CognitoUser(userData);
            console.log("UserLoginService: config is " + AWS.config);
            cognitoUser.authenticateUser(authenticationDetails, {
                newPasswordRequired: function (userAttributes, requiredAttributes) { return callback.cognitoCallback("User needs to set password.", null); },
                onSuccess: function (result) { return _this.onLoginSuccess(callback, result); },
                onFailure: function (err) { return _this.onLoginError(callback, err); },
                mfaRequired: function (challengeName, challengeParameters) {
                    callback.handleMFAStep(challengeName, challengeParameters, function (confirmationCode) {
                        cognitoUser.sendMFACode(confirmationCode, {
                            onSuccess: function (result) { return _this.onLoginSuccess(callback, result); },
                            onFailure: function (err) { return _this.onLoginError(callback, err); }
                        });
                    });
                }
            });
        };
        UserLoginService.prototype.forgotPassword = function (username, callback) {
            var userData = {
                Username: username,
                Pool: this.cognitoUtil.getUserPool()
            };
            var cognitoUser = new amazonCognitoIdentityJs.CognitoUser(userData);
            cognitoUser.forgotPassword({
                onSuccess: function () {
                },
                onFailure: function (err) {
                    callback.cognitoCallback(err.message, null);
                },
                inputVerificationCode: function () {
                    callback.cognitoCallback(null, null);
                }
            });
        };
        UserLoginService.prototype.confirmNewPassword = function (email, verificationCode, password, callback) {
            var userData = {
                Username: email,
                Pool: this.cognitoUtil.getUserPool()
            };
            var cognitoUser = new amazonCognitoIdentityJs.CognitoUser(userData);
            cognitoUser.confirmPassword(verificationCode, password, {
                onSuccess: function () {
                    callback.cognitoCallback(null, null);
                },
                onFailure: function (err) {
                    callback.cognitoCallback(err.message, null);
                }
            });
        };
        UserLoginService.prototype.logout = function () {
            console.log("UserLoginService: Logging out");
            this.cognitoUtil.getCurrentUser().signOut();
        };
        UserLoginService.prototype.isAuthenticated = function (callback) {
            if (callback == null)
                throw ("UserLoginService: Callback in isAuthenticated() cannot be null");
            var cognitoUser = this.cognitoUtil.getCurrentUser();
            if (cognitoUser != null) {
                cognitoUser.getSession(function (err, session) {
                    if (err) {
                        console.log("UserLoginService: Couldn't get the session: " + err, err.stack);
                        callback.isLoggedIn(err, false);
                    }
                    else {
                        console.log("UserLoginService: Session is " + session.isValid());
                        callback.isLoggedIn(err, session.isValid());
                    }
                });
            }
            else {
                console.log("UserLoginService: can't retrieve the current user");
                callback.isLoggedIn("Can't retrieve the CurrentUser", false);
            }
        };
        UserLoginService.decorators = [
            { type: core.Injectable },
        ];
        /** @nocollapse */
        UserLoginService.ctorParameters = function () { return [
            { type: CognitoUtil, },
        ]; };
        return UserLoginService;
    }());

    var ForgotPasswordStep1Component = (function () {
        function ForgotPasswordStep1Component(router$$1, userService) {
            this.router = router$$1;
            this.userService = userService;
            this.errorMessage = null;
        }
        ForgotPasswordStep1Component.prototype.onNext = function () {
            this.errorMessage = null;
            this.userService.forgotPassword(this.email, this);
        };
        ForgotPasswordStep1Component.prototype.cognitoCallback = function (message, result) {
            if (message == null && result == null) {
                //error
                this.router.navigate(['/home/forgotPassword', this.email]);
            }
            else {
                //success
                this.errorMessage = message;
            }
        };
        ForgotPasswordStep1Component.decorators = [
            { type: core.Component, args: [{
                        selector: 'awscognito-angular2-app',
                        templateUrl: './forgot-password-step1.component.html',
                        styleUrls: ['./forgot-password-step1.component.css']
                    },] },
        ];
        /** @nocollapse */
        ForgotPasswordStep1Component.ctorParameters = function () { return [
            { type: router.Router, },
            { type: UserLoginService, },
        ]; };
        return ForgotPasswordStep1Component;
    }());

    var ForgotPasswordStep2Component = (function () {
        function ForgotPasswordStep2Component(router$$1, route, userService) {
            this.router = router$$1;
            this.route = route;
            this.userService = userService;
            console.log("email from the url: " + this.email);
        }
        ForgotPasswordStep2Component.prototype.ngOnInit = function () {
            var _this = this;
            this.sub = this.route.params.subscribe(function (params) {
                _this.email = params['email'];
            });
            this.errorMessage = null;
        };
        ForgotPasswordStep2Component.prototype.ngOnDestroy = function () {
            this.sub.unsubscribe();
        };
        ForgotPasswordStep2Component.prototype.onNext = function () {
            this.errorMessage = null;
            this.userService.confirmNewPassword(this.email, this.verificationCode, this.password, this);
        };
        ForgotPasswordStep2Component.prototype.cognitoCallback = function (message) {
            if (message != null) {
                //error
                this.errorMessage = message;
                console.log("result: " + this.errorMessage);
            }
            else {
                //success
                this.router.navigate(['/home/login']);
            }
        };
        ForgotPasswordStep2Component.decorators = [
            { type: core.Component, args: [{
                        selector: 'awscognito-angular2-app',
                        templateUrl: './forgot-password-step2.component.html',
                        styleUrls: ['./forgot-password-step2.component.css']
                    },] },
        ];
        /** @nocollapse */
        ForgotPasswordStep2Component.ctorParameters = function () { return [
            { type: router.Router, },
            { type: router.ActivatedRoute, },
            { type: UserLoginService, },
        ]; };
        return ForgotPasswordStep2Component;
    }());

    var LoginComponent = (function () {
        function LoginComponent(router$$1, userService) {
            this.router = router$$1;
            this.userService = userService;
            this.mfaStep = false;
            this.mfaData = {
                destination: '',
                callback: null
            };
            console.log("LoginComponent constructor");
        }
        LoginComponent.prototype.ngOnInit = function () {
            this.errorMessage = null;
            console.log("Checking if the user is already authenticated. If so, then redirect to the secure site");
            this.userService.isAuthenticated(this);
        };
        LoginComponent.prototype.onLogin = function () {
            if (this.email == null || this.password == null) {
                this.errorMessage = "All fields are required";
                return;
            }
            this.errorMessage = null;
            this.userService.authenticate(this.email, this.password, this);
        };
        LoginComponent.prototype.cognitoCallback = function (message, result) {
            if (message != null) {
                //error
                this.errorMessage = message;
                console.log("result: " + this.errorMessage);
                if (this.errorMessage === 'User is not confirmed.') {
                    console.log("redirecting");
                    this.router.navigate(['/home/confirmRegistration', this.email]);
                }
                else if (this.errorMessage === 'User needs to set password.') {
                    console.log("redirecting to set new password");
                    this.router.navigate(['/home/newPassword']);
                }
            }
            else {
                //success
                this.router.navigate(['/securehome']);
            }
        };
        LoginComponent.prototype.handleMFAStep = function (challengeName, challengeParameters, callback) {
            var _this = this;
            this.mfaStep = true;
            this.mfaData.destination = challengeParameters.CODE_DELIVERY_DESTINATION;
            this.mfaData.callback = function (code) {
                if (code == null || code.length === 0) {
                    _this.errorMessage = "Code is required";
                    return;
                }
                _this.errorMessage = null;
                callback(code);
            };
        };
        LoginComponent.prototype.isLoggedIn = function (message, isLoggedIn) {
            if (isLoggedIn) {
                this.router.navigate(['/securehome']);
            }
        };
        LoginComponent.prototype.cancelMFA = function () {
            this.mfaStep = false;
            return false; //necessary to prevent href navigation
        };
        LoginComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'awscognito-angular2-app',
                        templateUrl: './login.component.html',
                        styleUrls: ['./login.component.css']
                    },] },
        ];
        /** @nocollapse */
        LoginComponent.ctorParameters = function () { return [
            { type: router.Router, },
            { type: UserLoginService, },
        ]; };
        return LoginComponent;
    }());

    var LogoutComponent = (function () {
        function LogoutComponent(router$$1, userService) {
            this.router = router$$1;
            this.userService = userService;
            this.userService.isAuthenticated(this);
        }
        LogoutComponent.prototype.isLoggedIn = function (message, isLoggedIn) {
            if (isLoggedIn) {
                this.userService.logout();
                this.router.navigate(['/home']);
            }
            this.router.navigate(['/home']);
        };
        LogoutComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'app-logout',
                        template: '',
                    },] },
        ];
        /** @nocollapse */
        LogoutComponent.ctorParameters = function () { return [
            { type: router.Router, },
            { type: UserLoginService, },
        ]; };
        return LogoutComponent;
    }());

    var MfaComponent = (function () {
        function MfaComponent() {
            console.log("MFAComponent constructor");
        }
        MfaComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'awscognito-mfa',
                        templateUrl: './mfa.component.html'
                    },] },
        ];
        /** @nocollapse */
        MfaComponent.ctorParameters = function () { return []; };
        MfaComponent.propDecorators = {
            "destination": [{ type: core.Input },],
            "onSubmit": [{ type: core.Input },],
        };
        return MfaComponent;
    }());

    var UserRegistrationService = (function () {
        function UserRegistrationService(cognitoUtil) {
            this.cognitoUtil = cognitoUtil;
        }
        UserRegistrationService.prototype.register = function (user, callback) {
            console.log("UserRegistrationService: user is " + user);
            var attributeList = [];
            var dataEmail = {
                Name: 'email',
                Value: user.email
            };
            attributeList.push(new amazonCognitoIdentityJs.CognitoUserAttribute(dataEmail));
            attributeList.push(new amazonCognitoIdentityJs.CognitoUserAttribute({
                Name: 'phone_number',
                Value: user.phone_number
            }));
            attributeList.push(new amazonCognitoIdentityJs.CognitoUserAttribute({
                Name: 'gender',
                Value: user.gender
            }));
            attributeList.push(new amazonCognitoIdentityJs.CognitoUserAttribute({
                Name: 'family_name',
                Value: user.family_name
            }));
            attributeList.push(new amazonCognitoIdentityJs.CognitoUserAttribute({
                Name: 'given_name',
                Value: user.given_name
            }));
            attributeList.push(new amazonCognitoIdentityJs.CognitoUserAttribute({
                Name: 'birthdate',
                Value: user.birth_date
            }));
            attributeList.push(new amazonCognitoIdentityJs.CognitoUserAttribute({
                Name: 'gender',
                Value: user.gender
            }));
            this.cognitoUtil.getUserPool().signUp(user.name, user.password, attributeList, null, function (err, result) {
                if (err) {
                    callback.cognitoCallback(err.message, null);
                }
                else {
                    console.log("UserRegistrationService: registered user is " + result);
                    callback.cognitoCallback(null, result);
                }
            });
        };
        UserRegistrationService.prototype.confirmRegistration = function (username, confirmationCode, callback) {
            var userData = {
                Username: username,
                Pool: this.cognitoUtil.getUserPool()
            };
            var cognitoUser = new amazonCognitoIdentityJs.CognitoUser(userData);
            cognitoUser.confirmRegistration(confirmationCode, true, function (err, result) {
                if (err) {
                    callback.cognitoCallback(err.message, null);
                }
                else {
                    callback.cognitoCallback(null, result);
                }
            });
        };
        UserRegistrationService.prototype.resendCode = function (username, callback) {
            var userData = {
                Username: username,
                Pool: this.cognitoUtil.getUserPool()
            };
            var cognitoUser = new amazonCognitoIdentityJs.CognitoUser(userData);
            cognitoUser.resendConfirmationCode(function (err, result) {
                if (err) {
                    callback.cognitoCallback(err.message, null);
                }
                else {
                    callback.cognitoCallback(null, result);
                }
            });
        };
        UserRegistrationService.prototype.newPassword = function (newPasswordUser, callback) {
            console.log(newPasswordUser);
            // Get these details and call
            //cognitoUser.completeNewPasswordChallenge(newPassword, userAttributes, this);
            var authenticationData = {
                Username: newPasswordUser.username,
                Password: newPasswordUser.existingPassword,
            };
            var authenticationDetails = new amazonCognitoIdentityJs.AuthenticationDetails(authenticationData);
            var userData = {
                Username: newPasswordUser.username,
                Pool: this.cognitoUtil.getUserPool()
            };
            console.log("UserLoginService: Params set...Authenticating the user");
            var cognitoUser = new amazonCognitoIdentityJs.CognitoUser(userData);
            console.log("UserLoginService: config is " + AWS.config);
            cognitoUser.authenticateUser(authenticationDetails, {
                newPasswordRequired: function (userAttributes, requiredAttributes) {
                    // User was signed up by an admin and must provide new
                    // password and required attributes, if any, to complete
                    // authentication.
                    // the api doesn't accept this field back
                    delete userAttributes.email_verified;
                    cognitoUser.completeNewPasswordChallenge(newPasswordUser.password, requiredAttributes, {
                        onSuccess: function (result) {
                            callback.cognitoCallback(null, userAttributes);
                        },
                        onFailure: function (err) {
                            callback.cognitoCallback(err, null);
                        }
                    });
                },
                onSuccess: function (result) {
                    callback.cognitoCallback(null, result);
                },
                onFailure: function (err) {
                    callback.cognitoCallback(err, null);
                }
            });
        };
        UserRegistrationService.decorators = [
            { type: core.Injectable },
        ];
        /** @nocollapse */
        UserRegistrationService.ctorParameters = function () { return [
            { type: CognitoUtil, decorators: [{ type: core.Inject, args: [CognitoUtil,] },] },
        ]; };
        return UserRegistrationService;
    }());

    var NewPasswordComponent = (function () {
        function NewPasswordComponent(userRegistration, userService, router$$1) {
            this.userRegistration = userRegistration;
            this.userService = userService;
            this.router = router$$1;
            this.onInit();
        }
        NewPasswordComponent.prototype.onInit = function () {
            this.registrationUser = new NewPasswordUser();
            this.errorMessage = null;
        };
        NewPasswordComponent.prototype.ngOnInit = function () {
            this.errorMessage = null;
            console.log("Checking if the user is already authenticated. If so, then redirect to the secure site");
            this.userService.isAuthenticated(this);
        };
        NewPasswordComponent.prototype.onRegister = function () {
            console.log(this.registrationUser);
            this.errorMessage = null;
            this.userRegistration.newPassword(this.registrationUser, this);
        };
        NewPasswordComponent.prototype.cognitoCallback = function (message, result) {
            if (message != null) {
                //error
                this.errorMessage = message;
                console.log("result: " + this.errorMessage);
            }
            else {
                //success
                //move to the next step
                console.log("redirecting");
                this.router.navigate(['/securehome']);
            }
        };
        NewPasswordComponent.prototype.isLoggedIn = function (message, isLoggedIn) {
            if (isLoggedIn)
                this.router.navigate(['/securehome']);
        };
        NewPasswordComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'awscognito-angular2-app',
                        templateUrl: './new-password.component.html',
                        styleUrls: ['./new-password.component.css']
                    },] },
        ];
        /** @nocollapse */
        NewPasswordComponent.ctorParameters = function () { return [
            { type: UserRegistrationService, },
            { type: UserLoginService, },
            { type: router.Router, },
        ]; };
        return NewPasswordComponent;
    }());

    var RegisterComponent = (function () {
        function RegisterComponent(userRegistration, router$$1) {
            this.userRegistration = userRegistration;
            this.router = router$$1;
            this.onInit();
        }
        RegisterComponent.prototype.onInit = function () {
            this.registrationUser = new RegistrationUser();
            this.errorMessage = null;
        };
        RegisterComponent.prototype.onRegister = function () {
            this.errorMessage = null;
            this.userRegistration.register(this.registrationUser, this);
        };
        RegisterComponent.prototype.cognitoCallback = function (message, result) {
            if (message != null) {
                //error
                this.errorMessage = message;
                console.log("result: " + this.errorMessage);
            }
            else {
                //success
                //move to the next step
                console.log("redirecting");
                this.router.navigate(['/home/confirmRegistration', result.user.username]);
            }
        };
        RegisterComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'awscognito-angular2-app',
                        templateUrl: './register.component.html',
                        styleUrls: ['./register.component.css']
                    },] },
        ];
        /** @nocollapse */
        RegisterComponent.ctorParameters = function () { return [
            { type: UserRegistrationService, },
            { type: router.Router, },
        ]; };
        return RegisterComponent;
    }());

    var RegistrationConfirmationComponent = (function () {
        function RegistrationConfirmationComponent(regService, router$$1, route) {
            this.regService = regService;
            this.router = router$$1;
            this.route = route;
        }
        RegistrationConfirmationComponent.prototype.ngOnInit = function () {
            var _this = this;
            this.sub = this.route.params.subscribe(function (params) {
                _this.email = params['username'];
            });
            this.errorMessage = null;
        };
        RegistrationConfirmationComponent.prototype.ngOnDestroy = function () {
            this.sub.unsubscribe();
        };
        RegistrationConfirmationComponent.prototype.onConfirmRegistration = function () {
            this.errorMessage = null;
            this.regService.confirmRegistration(this.email, this.confirmationCode, this);
        };
        RegistrationConfirmationComponent.prototype.cognitoCallback = function (message, result) {
            if (message != null) {
                //error
                this.errorMessage = message;
                console.log("message: " + this.errorMessage);
            }
            else {
                //success
                //move to the next step
                console.log("Moving to securehome");
                // this.configs.curUser = result.user;
                this.router.navigate(['/securehome']);
            }
        };
        RegistrationConfirmationComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'awscognito-angular2-app',
                        templateUrl: './registration-confirmation.component.html',
                        styleUrls: ['./registration-confirmation.component.css']
                    },] },
        ];
        /** @nocollapse */
        RegistrationConfirmationComponent.ctorParameters = function () { return [
            { type: UserRegistrationService, },
            { type: router.Router, },
            { type: router.ActivatedRoute, },
        ]; };
        return RegistrationConfirmationComponent;
    }());

    var ResendCodeComponent = (function () {
        function ResendCodeComponent(registrationService, router$$1) {
            this.registrationService = registrationService;
            this.router = router$$1;
        }
        ResendCodeComponent.prototype.resendCode = function () {
            this.registrationService.resendCode(this.email, this);
        };
        ResendCodeComponent.prototype.cognitoCallback = function (error, result) {
            if (error != null) {
                this.errorMessage = "Ha ocurrido un problema...por favor intente mas tarde.";
            }
            else {
                this.router.navigate(['/home/confirmRegistration', this.email]);
            }
        };
        ResendCodeComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'awscognito-angular2-app',
                        templateUrl: './resend-code.component.html',
                        styleUrls: ['./resend-code.component.css']
                    },] },
        ];
        /** @nocollapse */
        ResendCodeComponent.ctorParameters = function () { return [
            { type: UserRegistrationService, },
            { type: router.Router, },
        ]; };
        return ResendCodeComponent;
    }());

    /**
     * Created by Vladimir Budilov
     */
    // declare var AMA: any;
    var AwsUtil = (function () {
        function AwsUtil(cognitoUtil) {
            this.cognitoUtil = cognitoUtil;
            AWS.config.region = CognitoUtil._REGION;
        }
        /**
         * This is the method that needs to be called in order to init the aws global creds
         */
        /**
             * This is the method that needs to be called in order to init the aws global creds
             */
        AwsUtil.prototype.initAwsService = /**
             * This is the method that needs to be called in order to init the aws global creds
             */
        function (callback, isLoggedIn, idToken) {
            if (AwsUtil.runningInit) {
                // Need to make sure I don't get into an infinite loop here, so need to exit if this method is running already
                console.log("AwsUtil: Aborting running initAwsService()...it's running already.");
                // instead of aborting here, it's best to put a timer
                if (callback != null) {
                    callback.callback();
                    callback.callbackWithParam(null);
                }
                return;
            }
            console.log("AwsUtil: Running initAwsService()");
            AwsUtil.runningInit = true;
            var mythis = this;
            // First check if the user is authenticated already
            if (isLoggedIn)
                mythis.setupAWS(isLoggedIn, callback, idToken);
        };
        /**
         * Sets up the AWS global params
         *
         * @param isLoggedIn
         * @param callback
         */
        /**
             * Sets up the AWS global params
             *
             * @param isLoggedIn
             * @param callback
             */
        AwsUtil.prototype.setupAWS = /**
             * Sets up the AWS global params
             *
             * @param isLoggedIn
             * @param callback
             */
        function (isLoggedIn, callback, idToken) {
            console.log("AwsUtil: in setupAWS()");
            if (isLoggedIn) {
                console.log("AwsUtil: User is logged in");
                // TODO: The mobile Analytics client needs some work to handle Typescript. Disabling for the time being.
                // var mobileAnalyticsClient = new AMA.Manager(options);
                // mobileAnalyticsClient.submitEvents();
                this.addCognitoCredentials(idToken);
                console.log("AwsUtil: Retrieving the id token");
            }
            else {
                console.log("AwsUtil: User is not logged in");
            }
            if (callback != null) {
                callback.callback();
                callback.callbackWithParam(null);
            }
            AwsUtil.runningInit = false;
        };
        AwsUtil.prototype.addCognitoCredentials = function (idTokenJwt) {
            var creds = this.cognitoUtil.buildCognitoCreds(idTokenJwt);
            AWS.config.credentials = creds;
            creds.get(function (err) {
                if (!err) {
                    if (AwsUtil.firstLogin) {
                        AwsUtil.firstLogin = false;
                    }
                }
            });
        };
        AwsUtil.getCognitoParametersForIdConsolidation = function (idTokenJwt) {
            console.log("AwsUtil: enter getCognitoParametersForIdConsolidation()");
            var url = 'cognito-idp.' + CognitoUtil._REGION.toLowerCase() + '.amazonaws.com/' + CognitoUtil._USER_POOL_ID;
            var logins = [];
            logins[url] = idTokenJwt;
            logins['accounts.google.com'] = idTokenJwt;
            var params = {
                IdentityPoolId: CognitoUtil._IDENTITY_POOL_ID,
                /* required */
                Logins: logins
            };
            return params;
        };
        AwsUtil.firstLogin = false;
        AwsUtil.runningInit = false;
        AwsUtil.decorators = [
            { type: core.Injectable },
        ];
        /** @nocollapse */
        AwsUtil.ctorParameters = function () { return [
            { type: CognitoUtil, },
        ]; };
        return AwsUtil;
    }());

    var UserParametersService = (function () {
        function UserParametersService(cognitoUtil) {
            this.cognitoUtil = cognitoUtil;
        }
        UserParametersService.prototype.getParameters = function (callback) {
            var cognitoUser = this.cognitoUtil.getCurrentUser();
            if (cognitoUser != null) {
                cognitoUser.getSession(function (err, session) {
                    if (err)
                        console.log("UserParametersService: Couldn't retrieve the user");
                    else {
                        cognitoUser.getUserAttributes(function (err, result) {
                            if (err) {
                                console.log("UserParametersService: in getParameters: " + err);
                            }
                            else {
                                callback.callbackWithParam(result);
                            }
                        });
                    }
                });
            }
            else {
                callback.callbackWithParam(null);
            }
        };
        UserParametersService.decorators = [
            { type: core.Injectable },
        ];
        /** @nocollapse */
        UserParametersService.ctorParameters = function () { return [
            { type: CognitoUtil, },
        ]; };
        return UserParametersService;
    }());

    // const authRoutes: Routes = [
    //   {
    //     path: 'auth', component: LoginComponent, children: [
    //       {path: 'login', component: LoginComponent},
    //       {path: 'logout', component: LogoutComponent},
    //       {path: 'register', pathMatch: 'full', component: RegisterComponent},
    //       {path: 'confirmRegistration/:username', component: RegistrationConfirmationComponent},
    //       {path: 'resendCode', component: ResendCodeComponent},
    //       {path: 'forgotPassword/:email', component: ForgotPasswordStep2Component},
    //       {path: 'forgotPassword', component: ForgotPasswordStep1Component},
    //       {path: 'newPassword', component: NewPasswordComponent}
    //     ]
    //   }
    // ];
    var authRoutes = [
        { path: 'auth', component: LoginComponent },
        { path: 'auth/login', component: LoginComponent },
        { path: 'lauth/ogout', component: LogoutComponent },
        { path: 'auth/register', component: RegisterComponent },
        { path: 'auth/confirmRegistration/:username', component: RegistrationConfirmationComponent },
        { path: 'auth/resendCode', component: ResendCodeComponent },
        { path: 'auth/forgotPassword/:email', component: ForgotPasswordStep2Component },
        { path: 'auth/forgotPassword', component: ForgotPasswordStep1Component },
        { path: 'auth/newPassword', component: NewPasswordComponent }
    ];
    var WngAuthRoutingModule = (function () {
        function WngAuthRoutingModule() {
        }
        WngAuthRoutingModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            router.RouterModule.forChild(authRoutes)
                        ],
                        exports: [
                            router.RouterModule
                        ]
                    },] },
        ];
        /** @nocollapse */
        WngAuthRoutingModule.ctorParameters = function () { return []; };
        return WngAuthRoutingModule;
    }());

    var WngauthModule = (function () {
        function WngauthModule() {
        }
        WngauthModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule,
                            forms.FormsModule,
                            WngAuthRoutingModule
                        ],
                        declarations: [
                            ForgotPasswordStep1Component,
                            ForgotPasswordStep2Component,
                            LoginComponent,
                            LogoutComponent,
                            MfaComponent,
                            NewPasswordComponent,
                            RegisterComponent,
                            RegistrationConfirmationComponent,
                            ResendCodeComponent
                        ],
                        exports: [
                            ForgotPasswordStep1Component,
                            ForgotPasswordStep2Component,
                            LoginComponent,
                            LogoutComponent,
                            MfaComponent,
                            NewPasswordComponent,
                            RegisterComponent,
                            RegistrationConfirmationComponent,
                            ResendCodeComponent,
                            router.RouterModule
                        ]
                    },] },
        ];
        /** @nocollapse */
        WngauthModule.ctorParameters = function () { return []; };
        return WngauthModule;
    }());

    exports.NewPasswordUser = NewPasswordUser;
    exports.RegistrationUser = RegistrationUser;
    exports.Stuff = Stuff;
    exports.ForgotPasswordStep1Component = ForgotPasswordStep1Component;
    exports.ForgotPasswordStep2Component = ForgotPasswordStep2Component;
    exports.LoginComponent = LoginComponent;
    exports.LogoutComponent = LogoutComponent;
    exports.MfaComponent = MfaComponent;
    exports.NewPasswordComponent = NewPasswordComponent;
    exports.RegisterComponent = RegisterComponent;
    exports.RegistrationConfirmationComponent = RegistrationConfirmationComponent;
    exports.ResendCodeComponent = ResendCodeComponent;
    exports.AwsUtil = AwsUtil;
    exports.CognitoUtil = CognitoUtil;
    exports.UserLoginService = UserLoginService;
    exports.UserParametersService = UserParametersService;
    exports.UserRegistrationService = UserRegistrationService;
    exports.WngauthModule = WngauthModule;
    exports.WngAuthRoutingModule = WngAuthRoutingModule;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
