import { Component } from "@angular/core";
import { ActivatedRoute, Router } from "@angular/router";
import { UserLoginService } from "../../services/user-login.service";
var ForgotPasswordStep2Component = (function () {
    function ForgotPasswordStep2Component(router, route, userService) {
        this.router = router;
        this.route = route;
        this.userService = userService;
        console.log("email from the url: " + this.email);
    }
    ForgotPasswordStep2Component.prototype.ngOnInit = function () {
        var _this = this;
        this.sub = this.route.params.subscribe(function (params) {
            _this.email = params['email'];
        });
        this.errorMessage = null;
    };
    ForgotPasswordStep2Component.prototype.ngOnDestroy = function () {
        this.sub.unsubscribe();
    };
    ForgotPasswordStep2Component.prototype.onNext = function () {
        this.errorMessage = null;
        this.userService.confirmNewPassword(this.email, this.verificationCode, this.password, this);
    };
    ForgotPasswordStep2Component.prototype.cognitoCallback = function (message) {
        if (message != null) {
            //error
            this.errorMessage = message;
            console.log("result: " + this.errorMessage);
        }
        else {
            //success
            this.router.navigate(['/home/login']);
        }
    };
    ForgotPasswordStep2Component.decorators = [
        { type: Component, args: [{
                    selector: 'awscognito-angular2-app',
                    templateUrl: './forgot-password-step2.component.html',
                    styleUrls: ['./forgot-password-step2.component.css']
                },] },
    ];
    /** @nocollapse */
    ForgotPasswordStep2Component.ctorParameters = function () { return [
        { type: Router, },
        { type: ActivatedRoute, },
        { type: UserLoginService, },
    ]; };
    return ForgotPasswordStep2Component;
}());
export { ForgotPasswordStep2Component };
//# sourceMappingURL=forgot-password-step2.component.js.map