import { OnInit } from "@angular/core";
import { Router } from "@angular/router";
import { UserLoginService } from "../../services/user-login.service";
import { ChallengeParameters, CognitoCallback, LoggedInCallback } from "../../services/cognito.service";
export declare class LoginComponent implements CognitoCallback, LoggedInCallback, OnInit {
    router: Router;
    userService: UserLoginService;
    email: string;
    password: string;
    errorMessage: string;
    mfaStep: boolean;
    mfaData: {
        destination: string;
        callback: any;
    };
    constructor(router: Router, userService: UserLoginService);
    ngOnInit(): void;
    onLogin(): void;
    cognitoCallback(message: string, result: any): void;
    handleMFAStep(challengeName: string, challengeParameters: ChallengeParameters, callback: (confirmationCode: string) => any): void;
    isLoggedIn(message: string, isLoggedIn: boolean): void;
    cancelMFA(): boolean;
}
