import { Component } from "@angular/core";
import { Router } from "@angular/router";
import { UserRegistrationService } from "../../services/user-registration.service";
import { UserLoginService } from "../../services/user-login.service";
import { NewPasswordUser } from "../../model/NewPasswordUser";
var NewPasswordComponent = (function () {
    function NewPasswordComponent(userRegistration, userService, router) {
        this.userRegistration = userRegistration;
        this.userService = userService;
        this.router = router;
        this.onInit();
    }
    NewPasswordComponent.prototype.onInit = function () {
        this.registrationUser = new NewPasswordUser();
        this.errorMessage = null;
    };
    NewPasswordComponent.prototype.ngOnInit = function () {
        this.errorMessage = null;
        console.log("Checking if the user is already authenticated. If so, then redirect to the secure site");
        this.userService.isAuthenticated(this);
    };
    NewPasswordComponent.prototype.onRegister = function () {
        console.log(this.registrationUser);
        this.errorMessage = null;
        this.userRegistration.newPassword(this.registrationUser, this);
    };
    NewPasswordComponent.prototype.cognitoCallback = function (message, result) {
        if (message != null) {
            //error
            this.errorMessage = message;
            console.log("result: " + this.errorMessage);
        }
        else {
            //success
            //move to the next step
            console.log("redirecting");
            this.router.navigate(['/securehome']);
        }
    };
    NewPasswordComponent.prototype.isLoggedIn = function (message, isLoggedIn) {
        if (isLoggedIn)
            this.router.navigate(['/securehome']);
    };
    NewPasswordComponent.decorators = [
        { type: Component, args: [{
                    selector: 'awscognito-angular2-app',
                    templateUrl: './new-password.component.html',
                    styleUrls: ['./new-password.component.css']
                },] },
    ];
    /** @nocollapse */
    NewPasswordComponent.ctorParameters = function () { return [
        { type: UserRegistrationService, },
        { type: UserLoginService, },
        { type: Router, },
    ]; };
    return NewPasswordComponent;
}());
export { NewPasswordComponent };
//# sourceMappingURL=new-password.component.js.map