import { Component } from "@angular/core";
import { Router } from "@angular/router";
import { UserRegistrationService } from "../../services/user-registration.service";
import { RegistrationUser } from "../../model/RegistrationUser";
var RegisterComponent = (function () {
    function RegisterComponent(userRegistration, router) {
        this.userRegistration = userRegistration;
        this.router = router;
        this.onInit();
    }
    RegisterComponent.prototype.onInit = function () {
        this.registrationUser = new RegistrationUser();
        this.errorMessage = null;
    };
    RegisterComponent.prototype.onRegister = function () {
        this.errorMessage = null;
        this.userRegistration.register(this.registrationUser, this);
    };
    RegisterComponent.prototype.cognitoCallback = function (message, result) {
        if (message != null) {
            //error
            this.errorMessage = message;
            console.log("result: " + this.errorMessage);
        }
        else {
            //success
            //move to the next step
            console.log("redirecting");
            this.router.navigate(['/home/confirmRegistration', result.user.username]);
        }
    };
    RegisterComponent.decorators = [
        { type: Component, args: [{
                    selector: 'awscognito-angular2-app',
                    templateUrl: './register.component.html',
                    styleUrls: ['./register.component.css']
                },] },
    ];
    /** @nocollapse */
    RegisterComponent.ctorParameters = function () { return [
        { type: UserRegistrationService, },
        { type: Router, },
    ]; };
    return RegisterComponent;
}());
export { RegisterComponent };
//# sourceMappingURL=register.component.js.map