import { Component } from '@angular/core';
import { ActivatedRoute, Router } from "@angular/router";
import { UserRegistrationService } from "../../services/user-registration.service";
var RegistrationConfirmationComponent = (function () {
    function RegistrationConfirmationComponent(regService, router, route) {
        this.regService = regService;
        this.router = router;
        this.route = route;
    }
    RegistrationConfirmationComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.sub = this.route.params.subscribe(function (params) {
            _this.email = params['username'];
        });
        this.errorMessage = null;
    };
    RegistrationConfirmationComponent.prototype.ngOnDestroy = function () {
        this.sub.unsubscribe();
    };
    RegistrationConfirmationComponent.prototype.onConfirmRegistration = function () {
        this.errorMessage = null;
        this.regService.confirmRegistration(this.email, this.confirmationCode, this);
    };
    RegistrationConfirmationComponent.prototype.cognitoCallback = function (message, result) {
        if (message != null) {
            //error
            this.errorMessage = message;
            console.log("message: " + this.errorMessage);
        }
        else {
            //success
            //move to the next step
            console.log("Moving to securehome");
            // this.configs.curUser = result.user;
            this.router.navigate(['/securehome']);
        }
    };
    RegistrationConfirmationComponent.decorators = [
        { type: Component, args: [{
                    selector: 'awscognito-angular2-app',
                    templateUrl: './registration-confirmation.component.html',
                    styleUrls: ['./registration-confirmation.component.css']
                },] },
    ];
    /** @nocollapse */
    RegistrationConfirmationComponent.ctorParameters = function () { return [
        { type: UserRegistrationService, },
        { type: Router, },
        { type: ActivatedRoute, },
    ]; };
    return RegistrationConfirmationComponent;
}());
export { RegistrationConfirmationComponent };
//# sourceMappingURL=registration-confirmation.component.js.map