import { Callback, CognitoUtil } from "./cognito.service";
/**
 * Created by Vladimir Budilov
 */
export declare class AwsUtil {
    cognitoUtil: CognitoUtil;
    static firstLogin: boolean;
    static runningInit: boolean;
    constructor(cognitoUtil: CognitoUtil);
    /**
     * This is the method that needs to be called in order to init the aws global creds
     */
    initAwsService(callback: Callback, isLoggedIn: boolean, idToken: string): void;
    /**
     * Sets up the AWS global params
     *
     * @param isLoggedIn
     * @param callback
     */
    setupAWS(isLoggedIn: boolean, callback: Callback, idToken: string): void;
    addCognitoCredentials(idTokenJwt: string): void;
    static getCognitoParametersForIdConsolidation(idTokenJwt: string): {};
}
