import { Injectable } from "@angular/core";
import { CognitoUtil } from "./cognito.service";
import * as AWS from "aws-sdk/global";
/**
 * Created by Vladimir Budilov
 */
// declare var AMA: any;
var AwsUtil = (function () {
    function AwsUtil(cognitoUtil) {
        this.cognitoUtil = cognitoUtil;
        AWS.config.region = CognitoUtil._REGION;
    }
    /**
     * This is the method that needs to be called in order to init the aws global creds
     */
    /**
         * This is the method that needs to be called in order to init the aws global creds
         */
    AwsUtil.prototype.initAwsService = /**
         * This is the method that needs to be called in order to init the aws global creds
         */
    function (callback, isLoggedIn, idToken) {
        if (AwsUtil.runningInit) {
            // Need to make sure I don't get into an infinite loop here, so need to exit if this method is running already
            console.log("AwsUtil: Aborting running initAwsService()...it's running already.");
            // instead of aborting here, it's best to put a timer
            if (callback != null) {
                callback.callback();
                callback.callbackWithParam(null);
            }
            return;
        }
        console.log("AwsUtil: Running initAwsService()");
        AwsUtil.runningInit = true;
        var mythis = this;
        // First check if the user is authenticated already
        if (isLoggedIn)
            mythis.setupAWS(isLoggedIn, callback, idToken);
    };
    /**
     * Sets up the AWS global params
     *
     * @param isLoggedIn
     * @param callback
     */
    /**
         * Sets up the AWS global params
         *
         * @param isLoggedIn
         * @param callback
         */
    AwsUtil.prototype.setupAWS = /**
         * Sets up the AWS global params
         *
         * @param isLoggedIn
         * @param callback
         */
    function (isLoggedIn, callback, idToken) {
        console.log("AwsUtil: in setupAWS()");
        if (isLoggedIn) {
            console.log("AwsUtil: User is logged in");
            // Setup mobile analytics
            var options = {
                appId: '32673c035a0b40e99d6e1f327be0cb60',
                appTitle: "aws-cognito-angular2-quickstart"
            };
            // TODO: The mobile Analytics client needs some work to handle Typescript. Disabling for the time being.
            // var mobileAnalyticsClient = new AMA.Manager(options);
            // mobileAnalyticsClient.submitEvents();
            this.addCognitoCredentials(idToken);
            console.log("AwsUtil: Retrieving the id token");
        }
        else {
            console.log("AwsUtil: User is not logged in");
        }
        if (callback != null) {
            callback.callback();
            callback.callbackWithParam(null);
        }
        AwsUtil.runningInit = false;
    };
    AwsUtil.prototype.addCognitoCredentials = function (idTokenJwt) {
        var creds = this.cognitoUtil.buildCognitoCreds(idTokenJwt);
        AWS.config.credentials = creds;
        creds.get(function (err) {
            if (!err) {
                if (AwsUtil.firstLogin) {
                    AwsUtil.firstLogin = false;
                }
            }
        });
    };
    AwsUtil.getCognitoParametersForIdConsolidation = function (idTokenJwt) {
        console.log("AwsUtil: enter getCognitoParametersForIdConsolidation()");
        var url = 'cognito-idp.' + CognitoUtil._REGION.toLowerCase() + '.amazonaws.com/' + CognitoUtil._USER_POOL_ID;
        var logins = [];
        logins[url] = idTokenJwt;
        logins['accounts.google.com'] = idTokenJwt;
        var params = {
            IdentityPoolId: CognitoUtil._IDENTITY_POOL_ID,
            /* required */
            Logins: logins
        };
        return params;
    };
    AwsUtil.firstLogin = false;
    AwsUtil.runningInit = false;
    AwsUtil.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    AwsUtil.ctorParameters = function () { return [
        { type: CognitoUtil, },
    ]; };
    return AwsUtil;
}());
export { AwsUtil };
//# sourceMappingURL=aws.service.js.map