import { CognitoUserPool, CognitoUser } from "amazon-cognito-identity-js";
import * as AWS from "aws-sdk/global";
import { CognitoIdentityCredentials } from "aws-sdk/global";
/**
 * Created by Vladimir Budilov
 */
export interface CognitoCallback {
    cognitoCallback(message: string, result: any): void;
    handleMFAStep?(challengeName: string, challengeParameters: ChallengeParameters, callback: (confirmationCode: string) => any): void;
}
export interface LoggedInCallback {
    isLoggedIn(message: string, loggedIn: boolean): void;
}
export interface ChallengeParameters {
    CODE_DELIVERY_DELIVERY_MEDIUM: string;
    CODE_DELIVERY_DESTINATION: string;
}
export interface Callback {
    callback(): void;
    callbackWithParam(result: any): void;
}
export declare class CognitoUtil {
    static _REGION: string;
    static _IDENTITY_POOL_ID: string;
    static _USER_POOL_ID: string;
    static _CLIENT_ID: string;
    static _POOL_DATA: any;
    cognitoCreds: AWS.CognitoIdentityCredentials;
    getUserPool(): CognitoUserPool;
    getCurrentUser(): CognitoUser;
    setCognitoCreds(creds: AWS.CognitoIdentityCredentials): void;
    getCognitoCreds(): CognitoIdentityCredentials;
    buildCognitoCreds(idTokenJwt: string): CognitoIdentityCredentials;
    getCognitoIdentity(): string;
    getAccessToken(callback: Callback): void;
    getIdToken(callback: Callback): void;
    getRefreshToken(callback: Callback): void;
    refresh(): void;
}
