import { Injectable } from "@angular/core";
import { CognitoUtil } from "./cognito.service";
var UserParametersService = (function () {
    function UserParametersService(cognitoUtil) {
        this.cognitoUtil = cognitoUtil;
    }
    UserParametersService.prototype.getParameters = function (callback) {
        var cognitoUser = this.cognitoUtil.getCurrentUser();
        if (cognitoUser != null) {
            cognitoUser.getSession(function (err, session) {
                if (err)
                    console.log("UserParametersService: Couldn't retrieve the user");
                else {
                    cognitoUser.getUserAttributes(function (err, result) {
                        if (err) {
                            console.log("UserParametersService: in getParameters: " + err);
                        }
                        else {
                            callback.callbackWithParam(result);
                        }
                    });
                }
            });
        }
        else {
            callback.callbackWithParam(null);
        }
    };
    UserParametersService.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    UserParametersService.ctorParameters = function () { return [
        { type: CognitoUtil, },
    ]; };
    return UserParametersService;
}());
export { UserParametersService };
//# sourceMappingURL=user-parameters.service.js.map